﻿using System;
using System.Linq;
using Windows.Security.Credentials;

// The Blank Page item template is documented at https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace App2
{
    public class AccountTokenStorage
    {

        private const string _KeyName = "MicrosoftAccountToken";

        public void SaveMicrosoftAccountToken(string token)
        {
            var vault = new PasswordVault();

            PasswordCredential credential = null;

            try
            {
                // Try to get an existing credential from the vault.
                credential = vault.FindAllByResource(_KeyName).FirstOrDefault();
            }
            catch (Exception)
            {
                // When there is no matching resource an error occurs, which we ignore.
            }

            if (credential != null)
            {
                vault.Remove(credential);
            }

            credential = new PasswordCredential(_KeyName, "username-not-used", token);

            vault.Add(credential);
        }

        public string GetMicrosoftAccountToken()
        {
            var vault = new PasswordVault();

            PasswordCredential credential = null;

            try
            {
                // Try to get an existing credential from the vault.
                credential = vault.FindAllByResource(_KeyName).FirstOrDefault();
            }
            catch (Exception)
            {
                // When there is no matching resource an error occurs, which we ignore.
            }

            if (credential != null)
            {
                credential.RetrievePassword();

                return credential.Password;
            }
            else
            {
                return null;
            }
        }
    }
}
